;=================================================================
; Project Name	: LoadRtfFromRes
; Version		: 1.0
; Asm Compiler	: GoAsm v0.55.11 (http://www.GoDevTool.com)
; Linker		: GoLink v0.26.4
; Res Compiler	: GoRC v0.90.2
; GoAsm Include	: (http://www.assembler.ca)
; IDE			: RadAsm v2.2.1.0 (http://www.radasm.com)
; Date			: 16-11-2006 --> 16-11-2006
; Tested		: Win98, XP
; Original By   : Alexander Stoica in Pelles C, Translate into
;                 Assembly & modified/additions by Rudy Rooroh
;=================================================================


#include "LoadRtfFromRes.Inc"


CONST SECTION

RichEditDLL    		db 'RICHED20.DLL',0
StrFmt				db '#%d',0
Open				db 'Open',0


DATA SECTION

hInstance			dd ?
hRichEditDLL		dd ?
hWndRichEdit		dd ?
hResource			dd 0
dwResSize			dd 0
pbResData			dd 0
dwRead				dd 0
hResInfo			dd 0


CODE SECTION

Start:

	invoke	GetModuleHandle, 0
	mov		[hInstance], eax
	invoke	InitCommonControls
	invoke	LoadLibrary, addr RichEditDLL
	cmp		eax, 0
	je		>	
	mov		[hRichEditDLL], eax
	invoke	DialogBoxParam, [hInstance], IDD_MAINDLG, 0, addr DlgProc, 0
	invoke	FreeLibrary, [hRichEditDLL]
	:
	invoke	ExitProcess, 0


DlgProc FRAME hWnd, uMsg, wParam, lParam
	LOCAL	txtrg			:TEXTRANGE
	LOCAL	szTextBuff[32]	:B
	
	mov		eax, [uMsg]
	cmp 	eax, WM_INITDIALOG
	jne 	>.WMCOMMAND
	invoke	LoadIcon, [hInstance], IDR_MAINICON
	invoke	SendMessage, [hWnd], WM_SETICON, ICON_SMALL, eax
	invoke	GetDlgItem, [hWnd], IDC_MAINRED
	mov		[hWndRichEdit], eax
	invoke	SendMessage, [hWndRichEdit], EM_AUTOURLDETECT, TRUE, 0
	invoke	SendMessage, [hWndRichEdit], EM_SETEVENTMASK, 0, ENM_LINK + ENM_MOUSEEVENTS 
	invoke	LoadRtfResource, [hWndRichEdit], IDR_RTFDATA
	jmp		>>.EXIT
	
	.WMCOMMAND
	cmp		eax, WM_COMMAND
	jne		>.WMNOTIFY
	mov		edx, [wParam]
	movzx	eax, dx
	cmp		eax, IDOK
	jne		>>.EXIT
	invoke	EndDialog, [hWnd], 0
	jmp		>>.EXIT

	.WMNOTIFY
	cmp		eax, WM_NOTIFY
	jne		>.WMCLOSE
	mov		edx, [lParam]
	cmp		D[edx+NMHDR.code], EN_LINK
	jne		>
	cmp		D[edx+ENLINK.msg], WM_LBUTTONUP
	jne		>
	push	[edx+ENLINK.chrg.cpMin]
	pop		[txtrg.chrg.cpMin]
	push	[edx+ENLINK.chrg.cpMax]
	pop		[txtrg.chrg.cpMax]
	push	offset szTextBuff
	pop		[txtrg.lpstrText]
	invoke	SendMessage, [hWndRichEdit], EM_GETTEXTRANGE, 0, addr txtrg
	invoke	ShellExecute, [hWnd], addr Open, addr szTextBuff, 0, 0, SW_SHOWNORMAL
	:
	
	.WMCLOSE
	cmp		eax, WM_CLOSE
	jne		>.DEFPROC
	invoke	EndDialog, [hWnd], 0

	.DEFPROC
	mov		eax, FALSE
	ret

	.EXIT
	mov		eax, TRUE
	ret
	
ENDF


LoadRtfResource FRAME hWndRED, iResID
	LOCAL	edtstrm		:EDITSTREAM
	
	invoke	RtlZeroMemory, addr edtstrm, sizeof EDITSTREAM
	mov		D[edtstrm.pfnCallback], offset EditStreamCallback
	push	[iResID]
	pop		[edtstrm.dwCookie]
	mov		D[edtstrm.dwError], 0
	invoke	SendMessage, [hWndRED], EM_STREAMIN, SF_RTF, addr edtstrm
	mov		eax, D[edtstrm.dwError]
	ret
	
ENDF


EditStreamCallback FRAME dwCookie, pbBuff, cb, pcb
	uses 	esi, edi
	LOCAL	szResIdStr[32]	:B
	
	cmp		D[dwRead], 0
	jne		>
	invoke	wsprintf, addr szResIdStr, addr StrFmt, [dwCookie]
	invoke	FindResource, [hInstance], addr szResIdStr, RT_RCDATA
	cmp		eax, 0
	je		>
	mov		[hResInfo], eax
	invoke	LoadResource, [hInstance], eax
	cmp		eax, 0
	je		>
	mov		[hResource], eax
	invoke	SizeofResource, [hInstance], [hResInfo]
	cmp		eax, 0
	je		>
	mov		[dwResSize], eax
	invoke	LockResource, [hResource]
	mov		[pbResData], eax
	:
	mov		eax, [pbResData]
	test	eax, eax
	je		>>
	mov		ecx, [cb]
	xor		eax, eax
	mov		edi, [pbBuff]
	rep stosb
	mov		eax, [dwResSize]
	sub		eax, [dwRead]
	cmp		eax, [cb]
	jbe		>.lesRes
	mov		esi, [pbResData]
	add		esi, [dwRead]
	mov		ecx, [cb]
	mov		edi, [pbBuff]
	rep movsb
	mov		ecx, [cb]
	mov		eax, [pcb]
	mov		[eax], ecx
	add		[dwRead], ecx
	.lesRes
	mov		esi, [pbResData]
	add		esi, [dwRead]
	mov		ecx, [dwResSize]
	sub		ecx, [dwRead]
	mov		edi, [pbBuff]
	rep movsb
	mov		ecx, [dwResSize]
	sub		ecx, [dwRead]
	mov		eax, [pcb]
	mov		[eax], ecx
	invoke	FreeResource, [hResource]
	mov		D[hResource], 0
	mov		D[pbResData], 0
	mov		D[dwResSize], 0
	mov		D[dwRead], 0
	mov		eax, FALSE
	ret
	:
	mov		eax, TRUE
	ret
	
ENDF


